<template>
  <form @submit.prevent="submit">
    <formInput v-model="email" :errors="errors.email" icon="mdi:account" inputType="email" placeHolder="Email" autocomplete="email"/>
    <formInput v-model="password" :errors="errors.password" icon="mdi:lock" inputType="password" placeHolder="Password" autocomplete="new-password"/>
    <formInput v-model="confirmPassword" :errors="errors.confirmPassword" icon="mdi:lock" inputType="password" placeHolder="Confirm Password" autocomplete="confirm-new-password"/>

    <Button @click="submit" :state="state" enabledText="Register" loadingText="Signing up..."
      successText="New user created!" />
    <errorText :errors="errors.general" />
  </form>
  <div class="mt-2 text-center">
    <p> Already have an account? <a href="/login">Login</a> </p>
  </div>
</template>
  
<script setup lang="ts">
import formInput from "./form-input.vue";
import errorText from './error-text.vue';
import Button, { type State } from './button.vue';
import { ref, type Ref } from "vue";
import { delay } from "@/utils/helper";

const state: Ref<State> = ref("ENABLED");
const email = ref("");
const password = ref("");
const confirmPassword = ref("");
const errors = ref({
  email: "",
  password: "",
  confirmPassword: "",
  general: ""
});

const submit = async () => {
  resetError();

  if (!validInput())
    return;

  try {
    const body = { email: email.value, password: password.value };
    const response = await fetch("/api/auth/signup", {
      method: "POST",
      headers: { "Content-Type": "application/json" },
      body: JSON.stringify(body)
    });

    if (response.ok) {
      state.value = "SUCCESS";
      await delay();
      window.location.href = "/";
      return;
    }

    await handleErrors(response);
  } catch (error) {
    // console.log(error);
    errors.value.general = "Something went wrong, please try again";
  }
};

function resetError() {
  errors.value = {
    email: "",
    password: "",
    confirmPassword: "",
    general: ""
  };
}

function validInput(): boolean {
  const invalidEmail = email.value === "";
  const invalidPassword = password.value === "";
  const passwordsDoNotMatch = password.value !== confirmPassword.value;

  if (invalidEmail) {
    errors.value.email = "Email is required";
  }
  if (invalidPassword) {
    errors.value.password = "Password is required";
  }
  if (passwordsDoNotMatch) {
    errors.value.confirmPassword = "Passwords do not match";
  }
  
  if (invalidPassword || invalidEmail) {
    return false;
  }
  return true;
}

async function handleErrors(response: Response) {
  if (response.status === 400) {
    const message = (await response.json()).message;
    if (message.includes("password")) {
      errors.value.password = message;
      return;
    }
    if (message.includes("email")) {
      errors.value.email = message;
      return;
    }
    errors.value.general = message;
  }

  if (response.status === 409) {
    errors.value.email = "Email already exists";
    return;
  }

  if (response.status === 500) {
    errors.value.general = "Something went wrong, please try again";
    return;
  }
}

</script>
  